package org.codehaus.mojo.webtest;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on webtest-maven-plugin.<br/> Call <pre>  mvn webtest:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Wed Aug 17 19:03:41 CEST 2011
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.7)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:webtest-maven-plugin:1.0.0", 0 );
        append( sb, "", 0 );

        append( sb, "Canoo WebTest Maven Plugin", 0 );
        append( sb, "Canoo WebTest plugin for Maven2 and Maven3. Canoo WebTest is a free Java tools for functional testing of web applications and the plugin allows to run Canoo Webtests from within a Maven build.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 8 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "clean".equals( goal ) )
        {
            append( sb, "webtest:clean", 0 );
            append( sb, "Remove temporary data from running the Canoo WebTests. The following directories are deleted\n-\tresultpath\n-\treportdirectory\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "autorefresh (Default: true)", 2 );
                append( sb, "Specifies whether the client should automatically follow page refresh requests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.autorefresh}", 3 );
                append( sb, "", 0 );

                append( sb, "basepath", 2 );
                append( sb, "Defines the constant base path used to construct request URLs, e.g. \'shop\' can be considered a basepath in \'http:/www.myhost.com/shop/productlist\' and \'http:/www.myhost.com/shop/checkout\'.", 3 );
                append( sb, "Expression: ${webtest.basepath}", 3 );
                append( sb, "", 0 );

                append( sb, "failureproperty", 2 );
                append( sb, "Specifies the name of an ant property which is set to true if the test fails. When using this property, set \'haltonfailure\' to \'false\'. Then check the ant property after performing all of your tests and if set fail. This allows your tests to continue running even if some fail (allowing you to catch multiple errors with one test run) but still ultimately fails the build if anything went wrong.", 3 );
                append( sb, "Expression: ${webtest.failureproperty}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonerror (Default: false)", 2 );
                append( sb, "Determines if the execution of the current <webtest< stops if a program error (unhandled exception) is encountered in one of the test steps. An ANT BuildFailed exception will be raised if it is set to \'Yes\'. This will terminate the execution of the ANT script. Setting the option to \'false\' will stop the execution of the current <webtest> but continues with the next ANT task, e.g. another <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonerror}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonfailure (Default: false)", 2 );
                append( sb, "Determines if the execution of the current test halts if a failure of one of the test steps is detected, e.g. a <verify...> test did not pass. Even when set to \'false\' all of the trailing <step>s of the current <webtest> will be skipped but processing will continue with the next <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonfailure}", 3 );
                append( sb, "", 0 );

                append( sb, "host (Default: localhost)", 2 );
                append( sb, "Defines the hostname to use for executing requests, e.g. \'localhost\' or \'www.myhost.com\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.host}", 3 );
                append( sb, "", 0 );

                append( sb, "loglevel (Default: WARN)", 2 );
                append( sb, "Defines the loglevel passed to the ANT script", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.loglevel}", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 80)", 2 );
                append( sb, "Defines the port number to use for executing requests, e.g. \'8080\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.port}", 3 );
                append( sb, "", 0 );

                append( sb, "propertyprefix", 2 );
                append( sb, "String to prepend to project and dependency property names.", 3 );
                append( sb, "Expression: ${webtest.propertyprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "protocol (Default: http)", 2 );
                append( sb, "Defines the protocol to use for executing requests. \'http:\' and \'file:\' are currently the only supported protocols.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.protocol}", 3 );
                append( sb, "", 0 );

                append( sb, "reportdirectory (Default: ${basedir}/target/site/webtest)", 2 );
                append( sb, "The subdirectory created under site containing the webtest report.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportdirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "reportname (Default: index.html)", 2 );
                append( sb, "The name of the created report using XSLT", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportname}", 3 );
                append( sb, "", 0 );

                append( sb, "resultpath (Default: ${project.build.directory}/webtest/webtest-results)", 2 );
                append( sb, "Defines the resultpath of saved responses (for example last response).", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.resultpath}", 3 );
                append( sb, "", 0 );

                append( sb, "resultreporterclass (Default: com.canoo.webtest.reporting.XmlReporter)", 2 );
                append( sb, "Defines the class for report generation, e.g \'com.canoo.webtest.reporting.PlainTextReporter\' or \'com.canoo.webtest.reporting.XmlReporter\'.", 3 );
                append( sb, "Expression: ${webtest.resultreporterclass}", 3 );
                append( sb, "", 0 );

                append( sb, "saveprefix (Default: response)", 2 );
                append( sb, "Sets the name to use if the current response received from the target host is to be saved into a file. A unique id will also be appended after the prefix.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "saveresponse (Default: true)", 2 );
                append( sb, "Defines whether the last response received from the target host is saved into the file <saveprefix><uniqueId>.html. saveprefix is the value set in the <saveprefix> config element. uniqueId is a timestamp at the time the file is saved. This is especially helpful for debugging your tests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveresponse}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcedirectory (Default: ${basedir}/src/test/webtest)", 2 );
                append( sb, "Specifies the location of the source files to be used.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcedirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcefile (Default: webtest.xml)", 2 );
                append( sb, "The ANT file to be executed as globbing pattern within the \'sourcedirectory\'. Depending on you requirements you can choose a different file or multiple files. The default value is \'${basedir}/src/test/webtest/webtest.xml\'", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcefile}", 3 );
                append( sb, "", 0 );

                append( sb, "target (Default: all)", 2 );
                append( sb, "The ANT target to call when executing a Canoo WebTest script.", 3 );
                append( sb, "Expression: ${webtest.target}", 3 );
                append( sb, "", 0 );

                append( sb, "timeout (Default: 300)", 2 );
                append( sb, "Defines the timeout value in seconds for both connection and socket. The connection timeout is the maximum allowed time until a connection is etablished. The socket timeout is the timeout for waiting for data. A timeout value of zero is interpreted as an infinite timeout.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.timeout}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "webtest:help", 0 );
            append( sb, "Display help information on webtest-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0webtest:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "info".equals( goal ) )
        {
            append( sb, "webtest:info", 0 );
            append( sb, "Prints the configuration settings.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "autorefresh (Default: true)", 2 );
                append( sb, "Specifies whether the client should automatically follow page refresh requests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.autorefresh}", 3 );
                append( sb, "", 0 );

                append( sb, "basepath", 2 );
                append( sb, "Defines the constant base path used to construct request URLs, e.g. \'shop\' can be considered a basepath in \'http:/www.myhost.com/shop/productlist\' and \'http:/www.myhost.com/shop/checkout\'.", 3 );
                append( sb, "Expression: ${webtest.basepath}", 3 );
                append( sb, "", 0 );

                append( sb, "failureproperty", 2 );
                append( sb, "Specifies the name of an ant property which is set to true if the test fails. When using this property, set \'haltonfailure\' to \'false\'. Then check the ant property after performing all of your tests and if set fail. This allows your tests to continue running even if some fail (allowing you to catch multiple errors with one test run) but still ultimately fails the build if anything went wrong.", 3 );
                append( sb, "Expression: ${webtest.failureproperty}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonerror (Default: false)", 2 );
                append( sb, "Determines if the execution of the current <webtest< stops if a program error (unhandled exception) is encountered in one of the test steps. An ANT BuildFailed exception will be raised if it is set to \'Yes\'. This will terminate the execution of the ANT script. Setting the option to \'false\' will stop the execution of the current <webtest> but continues with the next ANT task, e.g. another <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonerror}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonfailure (Default: false)", 2 );
                append( sb, "Determines if the execution of the current test halts if a failure of one of the test steps is detected, e.g. a <verify...> test did not pass. Even when set to \'false\' all of the trailing <step>s of the current <webtest> will be skipped but processing will continue with the next <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonfailure}", 3 );
                append( sb, "", 0 );

                append( sb, "host (Default: localhost)", 2 );
                append( sb, "Defines the hostname to use for executing requests, e.g. \'localhost\' or \'www.myhost.com\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.host}", 3 );
                append( sb, "", 0 );

                append( sb, "loglevel (Default: WARN)", 2 );
                append( sb, "Defines the loglevel passed to the ANT script", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.loglevel}", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 80)", 2 );
                append( sb, "Defines the port number to use for executing requests, e.g. \'8080\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.port}", 3 );
                append( sb, "", 0 );

                append( sb, "propertyprefix", 2 );
                append( sb, "String to prepend to project and dependency property names.", 3 );
                append( sb, "Expression: ${webtest.propertyprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "protocol (Default: http)", 2 );
                append( sb, "Defines the protocol to use for executing requests. \'http:\' and \'file:\' are currently the only supported protocols.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.protocol}", 3 );
                append( sb, "", 0 );

                append( sb, "reportdirectory (Default: ${basedir}/target/site/webtest)", 2 );
                append( sb, "The subdirectory created under site containing the webtest report.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportdirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "reportname (Default: index.html)", 2 );
                append( sb, "The name of the created report using XSLT", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportname}", 3 );
                append( sb, "", 0 );

                append( sb, "resultpath (Default: ${project.build.directory}/webtest/webtest-results)", 2 );
                append( sb, "Defines the resultpath of saved responses (for example last response).", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.resultpath}", 3 );
                append( sb, "", 0 );

                append( sb, "resultreporterclass (Default: com.canoo.webtest.reporting.XmlReporter)", 2 );
                append( sb, "Defines the class for report generation, e.g \'com.canoo.webtest.reporting.PlainTextReporter\' or \'com.canoo.webtest.reporting.XmlReporter\'.", 3 );
                append( sb, "Expression: ${webtest.resultreporterclass}", 3 );
                append( sb, "", 0 );

                append( sb, "saveprefix (Default: response)", 2 );
                append( sb, "Sets the name to use if the current response received from the target host is to be saved into a file. A unique id will also be appended after the prefix.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "saveresponse (Default: true)", 2 );
                append( sb, "Defines whether the last response received from the target host is saved into the file <saveprefix><uniqueId>.html. saveprefix is the value set in the <saveprefix> config element. uniqueId is a timestamp at the time the file is saved. This is especially helpful for debugging your tests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveresponse}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcedirectory (Default: ${basedir}/src/test/webtest)", 2 );
                append( sb, "Specifies the location of the source files to be used.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcedirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcefile (Default: webtest.xml)", 2 );
                append( sb, "The ANT file to be executed as globbing pattern within the \'sourcedirectory\'. Depending on you requirements you can choose a different file or multiple files. The default value is \'${basedir}/src/test/webtest/webtest.xml\'", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcefile}", 3 );
                append( sb, "", 0 );

                append( sb, "target (Default: all)", 2 );
                append( sb, "The ANT target to call when executing a Canoo WebTest script.", 3 );
                append( sb, "Expression: ${webtest.target}", 3 );
                append( sb, "", 0 );

                append( sb, "timeout (Default: 300)", 2 );
                append( sb, "Defines the timeout value in seconds for both connection and socket. The connection timeout is the maximum allowed time until a connection is etablished. The socket timeout is the timeout for waiting for data. A timeout value of zero is interpreted as an infinite timeout.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.timeout}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "loop".equals( goal ) )
        {
            append( sb, "webtest:loop", 0 );
            append( sb, "Runs a Canoo WebTest in a loop until an error or failure occurs. This is handy when load testing and running the Canoo WebTests in parallel to ensure that the application still works.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "autorefresh (Default: true)", 2 );
                append( sb, "Specifies whether the client should automatically follow page refresh requests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.autorefresh}", 3 );
                append( sb, "", 0 );

                append( sb, "basepath", 2 );
                append( sb, "Defines the constant base path used to construct request URLs, e.g. \'shop\' can be considered a basepath in \'http:/www.myhost.com/shop/productlist\' and \'http:/www.myhost.com/shop/checkout\'.", 3 );
                append( sb, "Expression: ${webtest.basepath}", 3 );
                append( sb, "", 0 );

                append( sb, "failureproperty", 2 );
                append( sb, "Specifies the name of an ant property which is set to true if the test fails. When using this property, set \'haltonfailure\' to \'false\'. Then check the ant property after performing all of your tests and if set fail. This allows your tests to continue running even if some fail (allowing you to catch multiple errors with one test run) but still ultimately fails the build if anything went wrong.", 3 );
                append( sb, "Expression: ${webtest.failureproperty}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonerror (Default: false)", 2 );
                append( sb, "Determines if the execution of the current <webtest< stops if a program error (unhandled exception) is encountered in one of the test steps. An ANT BuildFailed exception will be raised if it is set to \'Yes\'. This will terminate the execution of the ANT script. Setting the option to \'false\' will stop the execution of the current <webtest> but continues with the next ANT task, e.g. another <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonerror}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonfailure (Default: false)", 2 );
                append( sb, "Determines if the execution of the current test halts if a failure of one of the test steps is detected, e.g. a <verify...> test did not pass. Even when set to \'false\' all of the trailing <step>s of the current <webtest> will be skipped but processing will continue with the next <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonfailure}", 3 );
                append( sb, "", 0 );

                append( sb, "host (Default: localhost)", 2 );
                append( sb, "Defines the hostname to use for executing requests, e.g. \'localhost\' or \'www.myhost.com\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.host}", 3 );
                append( sb, "", 0 );

                append( sb, "loglevel (Default: WARN)", 2 );
                append( sb, "Defines the loglevel passed to the ANT script", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.loglevel}", 3 );
                append( sb, "", 0 );

                append( sb, "loops", 2 );
                append( sb, "Defines the number of iterations for \'webtest:loop\'", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: 10", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 80)", 2 );
                append( sb, "Defines the port number to use for executing requests, e.g. \'8080\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.port}", 3 );
                append( sb, "", 0 );

                append( sb, "propertyprefix", 2 );
                append( sb, "String to prepend to project and dependency property names.", 3 );
                append( sb, "Expression: ${webtest.propertyprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "protocol (Default: http)", 2 );
                append( sb, "Defines the protocol to use for executing requests. \'http:\' and \'file:\' are currently the only supported protocols.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.protocol}", 3 );
                append( sb, "", 0 );

                append( sb, "reportdirectory (Default: ${basedir}/target/site/webtest)", 2 );
                append( sb, "The subdirectory created under site containing the webtest report.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportdirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "reportname (Default: index.html)", 2 );
                append( sb, "The name of the created report using XSLT", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportname}", 3 );
                append( sb, "", 0 );

                append( sb, "resultpath (Default: ${project.build.directory}/webtest/webtest-results)", 2 );
                append( sb, "Defines the resultpath of saved responses (for example last response).", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.resultpath}", 3 );
                append( sb, "", 0 );

                append( sb, "resultreporterclass (Default: com.canoo.webtest.reporting.XmlReporter)", 2 );
                append( sb, "Defines the class for report generation, e.g \'com.canoo.webtest.reporting.PlainTextReporter\' or \'com.canoo.webtest.reporting.XmlReporter\'.", 3 );
                append( sb, "Expression: ${webtest.resultreporterclass}", 3 );
                append( sb, "", 0 );

                append( sb, "saveprefix (Default: response)", 2 );
                append( sb, "Sets the name to use if the current response received from the target host is to be saved into a file. A unique id will also be appended after the prefix.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "saveresponse (Default: true)", 2 );
                append( sb, "Defines whether the last response received from the target host is saved into the file <saveprefix><uniqueId>.html. saveprefix is the value set in the <saveprefix> config element. uniqueId is a timestamp at the time the file is saved. This is especially helpful for debugging your tests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveresponse}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcedirectory (Default: ${basedir}/src/test/webtest)", 2 );
                append( sb, "Specifies the location of the source files to be used.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcedirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcefile (Default: webtest.xml)", 2 );
                append( sb, "The ANT file to be executed as globbing pattern within the \'sourcedirectory\'. Depending on you requirements you can choose a different file or multiple files. The default value is \'${basedir}/src/test/webtest/webtest.xml\'", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcefile}", 3 );
                append( sb, "", 0 );

                append( sb, "target (Default: all)", 2 );
                append( sb, "The ANT target to call when executing a Canoo WebTest script.", 3 );
                append( sb, "Expression: ${webtest.target}", 3 );
                append( sb, "", 0 );

                append( sb, "timeout (Default: 300)", 2 );
                append( sb, "Defines the timeout value in seconds for both connection and socket. The connection timeout is the maximum allowed time until a connection is etablished. The socket timeout is the timeout for waiting for data. A timeout value of zero is interpreted as an infinite timeout.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.timeout}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "report".equals( goal ) )
        {
            append( sb, "webtest:report", 0 );
            append( sb, "Creates the HTML report for a test run based on XSLT.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "reportdirectory", 2 );
                append( sb, "The subdirectory created under site containing the webtest report.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${basedir}/target/site/webtest", 3 );
                append( sb, "", 0 );

                append( sb, "reportname", 2 );
                append( sb, "The name of the created report using XSLT", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: index.html", 3 );
                append( sb, "", 0 );

                append( sb, "reportoverviewxsl", 2 );
                append( sb, "Defines the XSLT used to generate the WebTest report overview covering all test.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: WebTestReportOverview.xsl", 3 );
                append( sb, "", 0 );

                append( sb, "resultpath", 2 );
                append( sb, "Defines the resultpath of saved responses (for example last response). Under this directory Canoo WebTest will created test-related subfolders, e.g. \'001_GreenTest\'", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.directory}/webtest/webtest-results", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test".equals( goal ) )
        {
            append( sb, "webtest:test", 0 );
            append( sb, "Runs a Canoo WebTest defined in an ANT script.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "autorefresh (Default: true)", 2 );
                append( sb, "Specifies whether the client should automatically follow page refresh requests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.autorefresh}", 3 );
                append( sb, "", 0 );

                append( sb, "basepath", 2 );
                append( sb, "Defines the constant base path used to construct request URLs, e.g. \'shop\' can be considered a basepath in \'http:/www.myhost.com/shop/productlist\' and \'http:/www.myhost.com/shop/checkout\'.", 3 );
                append( sb, "Expression: ${webtest.basepath}", 3 );
                append( sb, "", 0 );

                append( sb, "failureproperty", 2 );
                append( sb, "Specifies the name of an ant property which is set to true if the test fails. When using this property, set \'haltonfailure\' to \'false\'. Then check the ant property after performing all of your tests and if set fail. This allows your tests to continue running even if some fail (allowing you to catch multiple errors with one test run) but still ultimately fails the build if anything went wrong.", 3 );
                append( sb, "Expression: ${webtest.failureproperty}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonerror (Default: false)", 2 );
                append( sb, "Determines if the execution of the current <webtest< stops if a program error (unhandled exception) is encountered in one of the test steps. An ANT BuildFailed exception will be raised if it is set to \'Yes\'. This will terminate the execution of the ANT script. Setting the option to \'false\' will stop the execution of the current <webtest> but continues with the next ANT task, e.g. another <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonerror}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonfailure (Default: false)", 2 );
                append( sb, "Determines if the execution of the current test halts if a failure of one of the test steps is detected, e.g. a <verify...> test did not pass. Even when set to \'false\' all of the trailing <step>s of the current <webtest> will be skipped but processing will continue with the next <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonfailure}", 3 );
                append( sb, "", 0 );

                append( sb, "host (Default: localhost)", 2 );
                append( sb, "Defines the hostname to use for executing requests, e.g. \'localhost\' or \'www.myhost.com\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.host}", 3 );
                append( sb, "", 0 );

                append( sb, "loglevel (Default: WARN)", 2 );
                append( sb, "Defines the loglevel passed to the ANT script", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.loglevel}", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 80)", 2 );
                append( sb, "Defines the port number to use for executing requests, e.g. \'8080\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.port}", 3 );
                append( sb, "", 0 );

                append( sb, "propertyprefix", 2 );
                append( sb, "String to prepend to project and dependency property names.", 3 );
                append( sb, "Expression: ${webtest.propertyprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "protocol (Default: http)", 2 );
                append( sb, "Defines the protocol to use for executing requests. \'http:\' and \'file:\' are currently the only supported protocols.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.protocol}", 3 );
                append( sb, "", 0 );

                append( sb, "reportdirectory (Default: ${basedir}/target/site/webtest)", 2 );
                append( sb, "The subdirectory created under site containing the webtest report.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportdirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "reportname (Default: index.html)", 2 );
                append( sb, "The name of the created report using XSLT", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportname}", 3 );
                append( sb, "", 0 );

                append( sb, "resultpath (Default: ${project.build.directory}/webtest/webtest-results)", 2 );
                append( sb, "Defines the resultpath of saved responses (for example last response).", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.resultpath}", 3 );
                append( sb, "", 0 );

                append( sb, "resultreporterclass (Default: com.canoo.webtest.reporting.XmlReporter)", 2 );
                append( sb, "Defines the class for report generation, e.g \'com.canoo.webtest.reporting.PlainTextReporter\' or \'com.canoo.webtest.reporting.XmlReporter\'.", 3 );
                append( sb, "Expression: ${webtest.resultreporterclass}", 3 );
                append( sb, "", 0 );

                append( sb, "saveprefix (Default: response)", 2 );
                append( sb, "Sets the name to use if the current response received from the target host is to be saved into a file. A unique id will also be appended after the prefix.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "saveresponse (Default: true)", 2 );
                append( sb, "Defines whether the last response received from the target host is saved into the file <saveprefix><uniqueId>.html. saveprefix is the value set in the <saveprefix> config element. uniqueId is a timestamp at the time the file is saved. This is especially helpful for debugging your tests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveresponse}", 3 );
                append( sb, "", 0 );

                append( sb, "sleepbeforestart", 2 );
                append( sb, "Defines the number of seconds to wait before starting a test.", 3 );
                append( sb, "Expression: 0", 3 );
                append( sb, "", 0 );

                append( sb, "sourcedirectory (Default: ${basedir}/src/test/webtest)", 2 );
                append( sb, "Specifies the location of the source files to be used.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcedirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcefile (Default: webtest.xml)", 2 );
                append( sb, "The ANT file to be executed as globbing pattern within the \'sourcedirectory\'. Depending on you requirements you can choose a different file or multiple files. The default value is \'${basedir}/src/test/webtest/webtest.xml\'", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcefile}", 3 );
                append( sb, "", 0 );

                append( sb, "target (Default: all)", 2 );
                append( sb, "The ANT target to call when executing a Canoo WebTest script.", 3 );
                append( sb, "Expression: ${webtest.target}", 3 );
                append( sb, "", 0 );

                append( sb, "timeout (Default: 300)", 2 );
                append( sb, "Defines the timeout value in seconds for both connection and socket. The connection timeout is the maximum allowed time until a connection is etablished. The socket timeout is the timeout for waiting for data. A timeout value of zero is interpreted as an infinite timeout.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.timeout}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "verify-filecontent".equals( goal ) )
        {
            append( sb, "webtest:verify-filecontent", 0 );
            append( sb, "Allows grepping through a set of files to find particular text strings and fail the build if one or matches are found. This is useful for checking HTML files (\'an application error occured\') or logfiles to decide if any exception are silently ignored by the web application.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "fileContentValidationSets", 2 );
                append( sb, "Specifies a set of files, which are being validated.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "verify-result".equals( goal ) )
        {
            append( sb, "webtest:verify-result", 0 );
            append( sb, "Checks the webtest result file for test failures and throws an exception if one or more tests failed. This is useful when \'haltonfailure\' and \'haltonerror\' are set to \'false\' thereby indicating a successful build even in the case that nothing worked. Invoking \'webtest:verify\' allows to fail the build later on behalf of the user.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "autorefresh (Default: true)", 2 );
                append( sb, "Specifies whether the client should automatically follow page refresh requests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.autorefresh}", 3 );
                append( sb, "", 0 );

                append( sb, "basepath", 2 );
                append( sb, "Defines the constant base path used to construct request URLs, e.g. \'shop\' can be considered a basepath in \'http:/www.myhost.com/shop/productlist\' and \'http:/www.myhost.com/shop/checkout\'.", 3 );
                append( sb, "Expression: ${webtest.basepath}", 3 );
                append( sb, "", 0 );

                append( sb, "failureproperty", 2 );
                append( sb, "Specifies the name of an ant property which is set to true if the test fails. When using this property, set \'haltonfailure\' to \'false\'. Then check the ant property after performing all of your tests and if set fail. This allows your tests to continue running even if some fail (allowing you to catch multiple errors with one test run) but still ultimately fails the build if anything went wrong.", 3 );
                append( sb, "Expression: ${webtest.failureproperty}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonerror (Default: false)", 2 );
                append( sb, "Determines if the execution of the current <webtest< stops if a program error (unhandled exception) is encountered in one of the test steps. An ANT BuildFailed exception will be raised if it is set to \'Yes\'. This will terminate the execution of the ANT script. Setting the option to \'false\' will stop the execution of the current <webtest> but continues with the next ANT task, e.g. another <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonerror}", 3 );
                append( sb, "", 0 );

                append( sb, "haltonfailure (Default: false)", 2 );
                append( sb, "Determines if the execution of the current test halts if a failure of one of the test steps is detected, e.g. a <verify...> test did not pass. Even when set to \'false\' all of the trailing <step>s of the current <webtest> will be skipped but processing will continue with the next <webtest>.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.haltonfailure}", 3 );
                append( sb, "", 0 );

                append( sb, "host (Default: localhost)", 2 );
                append( sb, "Defines the hostname to use for executing requests, e.g. \'localhost\' or \'www.myhost.com\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.host}", 3 );
                append( sb, "", 0 );

                append( sb, "loglevel (Default: WARN)", 2 );
                append( sb, "Defines the loglevel passed to the ANT script", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.loglevel}", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 80)", 2 );
                append( sb, "Defines the port number to use for executing requests, e.g. \'8080\'.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.port}", 3 );
                append( sb, "", 0 );

                append( sb, "propertyprefix", 2 );
                append( sb, "String to prepend to project and dependency property names.", 3 );
                append( sb, "Expression: ${webtest.propertyprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "protocol (Default: http)", 2 );
                append( sb, "Defines the protocol to use for executing requests. \'http:\' and \'file:\' are currently the only supported protocols.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.protocol}", 3 );
                append( sb, "", 0 );

                append( sb, "reportdirectory (Default: ${basedir}/target/site/webtest)", 2 );
                append( sb, "The subdirectory created under site containing the webtest report.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportdirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "reportname (Default: index.html)", 2 );
                append( sb, "The name of the created report using XSLT", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.reportname}", 3 );
                append( sb, "", 0 );

                append( sb, "resultpath (Default: ${project.build.directory}/webtest/webtest-results)", 2 );
                append( sb, "Defines the resultpath of saved responses (for example last response).", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.resultpath}", 3 );
                append( sb, "", 0 );

                append( sb, "resultreporterclass (Default: com.canoo.webtest.reporting.XmlReporter)", 2 );
                append( sb, "Defines the class for report generation, e.g \'com.canoo.webtest.reporting.PlainTextReporter\' or \'com.canoo.webtest.reporting.XmlReporter\'.", 3 );
                append( sb, "Expression: ${webtest.resultreporterclass}", 3 );
                append( sb, "", 0 );

                append( sb, "saveprefix (Default: response)", 2 );
                append( sb, "Sets the name to use if the current response received from the target host is to be saved into a file. A unique id will also be appended after the prefix.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveprefix}", 3 );
                append( sb, "", 0 );

                append( sb, "saveresponse (Default: true)", 2 );
                append( sb, "Defines whether the last response received from the target host is saved into the file <saveprefix><uniqueId>.html. saveprefix is the value set in the <saveprefix> config element. uniqueId is a timestamp at the time the file is saved. This is especially helpful for debugging your tests.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.saveresponse}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcedirectory (Default: ${basedir}/src/test/webtest)", 2 );
                append( sb, "Specifies the location of the source files to be used.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcedirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourcefile (Default: webtest.xml)", 2 );
                append( sb, "The ANT file to be executed as globbing pattern within the \'sourcedirectory\'. Depending on you requirements you can choose a different file or multiple files. The default value is \'${basedir}/src/test/webtest/webtest.xml\'", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.sourcefile}", 3 );
                append( sb, "", 0 );

                append( sb, "target (Default: all)", 2 );
                append( sb, "The ANT target to call when executing a Canoo WebTest script.", 3 );
                append( sb, "Expression: ${webtest.target}", 3 );
                append( sb, "", 0 );

                append( sb, "timeout (Default: 300)", 2 );
                append( sb, "Defines the timeout value in seconds for both connection and socket. The connection timeout is the maximum allowed time until a connection is etablished. The socket timeout is the timeout for waiting for data. A timeout value of zero is interpreted as an infinite timeout.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${webtest.timeout}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
